# https://help.github.com/en/categories/automating-your-workflow-with-github-actions

name: "Deploy API Reference"

on:
  push:
    branches:
      - "2.1.x"

concurrency:
  group: "pages"
  cancel-in-progress: false

jobs:
  build:
    name: "Build API References Pages"
    runs-on: "ubuntu-latest"

    strategy:
      matrix:
        branch:
          - "1.23.x"
          - "2.0.x"
          - "2.1.x"

    steps:
      - name: "Checkout"
        uses: actions/checkout@v4
        with:
          ref: ${{ matrix.branch }}

      - name: "Install PHP"
        uses: "shivammathur/setup-php@v2"
        with:
          coverage: "none"
          php-version: "8.1"
          extensions: mbstring
          tools: composer:v2

      - name: "Install dependencies"
        run: "composer update --no-interaction --no-progress"

      - name: "Install ApiGen dependencies"
        working-directory: "apigen"
        run: "composer install --no-interaction --no-progress"

      - name: "Run ApiGen"
        run: "apigen/vendor/bin/apigen -c apigen/apigen.neon --output docs/${{ matrix.branch }} -- src"

      - name: "Copy favicon"
        run: "cp apigen/favicon.png docs/favicon.png"

      - uses: actions/upload-artifact@v4
        with:
          name: docs-${{ matrix.branch }}
          path: docs/*

  merge:
    name: "Merge docs"
    needs: build

    runs-on: "ubuntu-latest"

    steps:
      - uses: actions/download-artifact@v4
        with:
          pattern: docs-*
          path: docs
          merge-multiple: true

      - name: Upload artifact
        uses: actions/upload-pages-artifact@v3
        with:
          path: 'docs'

  deploy:
    needs: merge

    # from https://github.com/actions/deploy-pages

    permissions:
      pages: write
      id-token: write

    environment:
      name: github-pages
      url: ${{ steps.deployment.outputs.page_url }}

    runs-on: ubuntu-latest
    steps:
      - name: Deploy to GitHub Pages
        id: deployment
        uses: actions/deploy-pages@v4
